﻿;==========================================================================================================================================================
; Rebuild the image list as it gets trashed by the clear command
;==========================================================================================================================================================

Procedure BuildImageList(Gadget.i)
  
  ;------------------------------------------------------------------------------------------------
  ; Create a new image list for the ListIconGadget if it doesn't exist or has been destroyed
  ;------------------------------------------------------------------------------------------------
  
  If Icon\HeaderListIcon = 0
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    Icon\HeaderListIcon       = ImageList_Create_(16, 16, #ILC_MASK | #ILC_COLOR32, 0, 39)
    
    ;----------------------------------------------------------------------------------------------
    ; Add the deleted icon to the new imagelist
    ;----------------------------------------------------------------------------------------------
    
    Icon\ListDeleted          = ImageList_ReplaceIcon_(Icon\HeaderListIcon, -1, ImageID(#ListDeleted))
    
    ;----------------------------------------------------------------------------------------------
    ; Add the category icons to the new imagelist
    ;----------------------------------------------------------------------------------------------
    
    Icon\CatUnknown           = ImageList_ReplaceIcon_(Icon\HeaderListIcon, -1, ImageID(#CatUnknown))
    
    Icon\CatAeroplane         = ImageList_ReplaceIcon_(Icon\HeaderListIcon, -1, ImageID(#CatAeroplane))
    
    Icon\CatAmateur           = ImageList_ReplaceIcon_(Icon\HeaderListIcon, -1, ImageID(#CatAmateur))
    
    Icon\CatAmbulance         = ImageList_ReplaceIcon_(Icon\HeaderListIcon, -1, ImageID(#CatAmbulance))
    
    Icon\CatAnyu              = ImageList_ReplaceIcon_(Icon\HeaderListIcon, -1, ImageID(#CatAnyu))
    
    Icon\CatBank              = ImageList_ReplaceIcon_(Icon\HeaderListIcon, -1, ImageID(#CatBank))
    
    Icon\CatBus               = ImageList_ReplaceIcon_(Icon\HeaderListIcon, -1, ImageID(#CatBus))
    
    Icon\CatBusiness          = ImageList_ReplaceIcon_(Icon\HeaderListIcon, -1, ImageID(#CatBusiness))
    
    Icon\CatCamel             = ImageList_ReplaceIcon_(Icon\HeaderListIcon, -1, ImageID(#CatCamel))
    
    Icon\CatCbradio           = ImageList_ReplaceIcon_(Icon\HeaderListIcon, -1, ImageID(#CatCbradio))
    
    Icon\CatCfa               = ImageList_ReplaceIcon_(Icon\HeaderListIcon, -1, ImageID(#CatCfa))
    
    Icon\CatCharity           = ImageList_ReplaceIcon_(Icon\HeaderListIcon, -1, ImageID(#CatCharity))
    
    Icon\CatDentist           = ImageList_ReplaceIcon_(Icon\HeaderListIcon, -1, ImageID(#CatDentist))
    
    Icon\CatDoctor            = ImageList_ReplaceIcon_(Icon\HeaderListIcon, -1, ImageID(#CatDoctor))
    
    Icon\CatFire              = ImageList_ReplaceIcon_(Icon\HeaderListIcon, -1, ImageID(#CatFire))
    
    Icon\CatFireman           = ImageList_ReplaceIcon_(Icon\HeaderListIcon, -1, ImageID(#CatFireman))
    
    Icon\CatHospital          = ImageList_ReplaceIcon_(Icon\HeaderListIcon, -1, ImageID(#CatHospital))
    
    Icon\CatMedical           = ImageList_ReplaceIcon_(Icon\HeaderListIcon, -1, ImageID(#CatMedical))
    
    Icon\CatOptometrist       = ImageList_ReplaceIcon_(Icon\HeaderListIcon, -1, ImageID(#CatOptometrist))
    
    Icon\CatPersonal          = ImageList_ReplaceIcon_(Icon\HeaderListIcon, -1, ImageID(#CatPersonal))
    
    Icon\CatPhysiotherapist   = ImageList_ReplaceIcon_(Icon\HeaderListIcon, -1, ImageID(#CatPhysiotherapist))
    
    Icon\CatPolice            = ImageList_ReplaceIcon_(Icon\HeaderListIcon, -1, ImageID(#CatPolice))
    
    Icon\CatScouts            = ImageList_ReplaceIcon_(Icon\HeaderListIcon, -1, ImageID(#CatScouts))
    
    Icon\CatService           = ImageList_ReplaceIcon_(Icon\HeaderListIcon, -1, ImageID(#CatService))
    
    Icon\CatShopping          = ImageList_ReplaceIcon_(Icon\HeaderListIcon, -1, ImageID(#CatShopping))
    
    Icon\CatTaxi              = ImageList_ReplaceIcon_(Icon\HeaderListIcon, -1, ImageID(#CatTaxi))
    
    Icon\CatTradesman         = ImageList_ReplaceIcon_(Icon\HeaderListIcon, -1, ImageID(#CatTradesman))
    
    Icon\CatTrain             = ImageList_ReplaceIcon_(Icon\HeaderListIcon, -1, ImageID(#CatTrain))
    
    Icon\CatTruck             = ImageList_ReplaceIcon_(Icon\HeaderListIcon, -1, ImageID(#CatTruck))
    
    Icon\CatVeterinarian      = ImageList_ReplaceIcon_(Icon\HeaderListIcon, -1, ImageID(#CatVeterinarian))
    
    ;----------------------------------------------------------------------------------------------
    ; Add the status icons to the new imagelist
    ;----------------------------------------------------------------------------------------------
    
    Icon\StatusActive         = ImageList_ReplaceIcon_(Icon\HeaderListIcon, -1, ImageID(#StatusActive))
    
    Icon\StatusFinished       = ImageList_ReplaceIcon_(Icon\HeaderListIcon, -1, ImageID(#StatusFinished))
    
    ;----------------------------------------------------------------------------------------------
    ; Add the alarm icons to the new imagelist
    ;----------------------------------------------------------------------------------------------
    
    Icon\AlarmBlank           = ImageList_ReplaceIcon_(Icon\HeaderListIcon, -1, ImageID(#AlarmBlank))
    
    Icon\AlarmBlue            = ImageList_ReplaceIcon_(Icon\HeaderListIcon, -1, ImageID(#AlarmBlue))
    
    Icon\AlarmGreen           = ImageList_ReplaceIcon_(Icon\HeaderListIcon, -1, ImageID(#AlarmGreen))
    
    Icon\AlarmRed             = ImageList_ReplaceIcon_(Icon\HeaderListIcon, -1, ImageID(#AlarmRed))
    
    ;----------------------------------------------------------------------------------------------
    ; Add the time of day icons to the new imagelist
    ;----------------------------------------------------------------------------------------------
    
    Icon\LightNight           = ImageList_ReplaceIcon_(Icon\HeaderListIcon, -1, ImageID(#LightNight))
    
    Icon\LightMorning         = ImageList_ReplaceIcon_(Icon\HeaderListIcon, -1, ImageID(#LightMorning))
    
    Icon\LightNoon            = ImageList_ReplaceIcon_(Icon\HeaderListIcon, -1, ImageID(#LightNoon))
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; Set the new imagelist to the gadget
  ;------------------------------------------------------------------------------------------------
  
  SendMessage_(GadgetID(Gadget.i), #LVM_SETIMAGELIST, #LVSIL_SMALL, Icon\HeaderListIcon)
  
  ImageList_SetBkColor_(Icon\HeaderListIcon, #CLR_NONE)  
  
  SendMessage_(GadgetID(Gadget.i), #LVM_SETEXTENDEDLISTVIEWSTYLE, #LVS_EX_SUBITEMIMAGES, #LVS_EX_SUBITEMIMAGES) 
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure


; IDE Options = PureBasic 5.23 LTS (Windows - x86)
; CursorPosition = 136
; FirstLine = 96
; Folding = -
; EnableXP
; HideErrorLog