﻿;==========================================================================================================================================================
; Fade the window out gently, close it and reset the mutex
;==========================================================================================================================================================

Procedure CloseMyWindow(Window.i)

  ;------------------------------------------------------------------------------------------------
  ; Get the current line number
  ;------------------------------------------------------------------------------------------------

  FocusLine.i = Program\CurrentLine
    
  ;------------------------------------------------------------------------------------------------
  ; Remove hover events for windows
  ;------------------------------------------------------------------------------------------------
  
  Select Window.i
      
      ;--------------------------------------------------------------------------------------------
      ; Appointment data window
      ;--------------------------------------------------------------------------------------------
      
    Case  #Window_AppointmentData
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      RemoveHoverGadget(GadgetID(#Gadget_AppointmentData_Save))
    
      RemoveHoverGadget(GadgetID(#Gadget_AppointmentData_Exit))
      
      ;--------------------------------------------------------------------------------------------
      ; Alarm checker list
      ;--------------------------------------------------------------------------------------------
      
    Case  #Window_AppointmentAlarm
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      RemoveHoverGadget(GadgetID(#Gadget_AppointmentAlarm_Snooze))
      
      RemoveHoverGadget(GadgetID(#Gadget_AppointmentAlarm_StopSound))
      
      RemoveHoverGadget(GadgetID(#Gadget_AppointmentAlarm_Cancel))
      
      ;--------------------------------------------------------------------------------------------
      ; Extended find module
      ;--------------------------------------------------------------------------------------------
      
    Case  #Window_AppointmentFind
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      RemoveHoverGadget(GadgetID(#Gadget_AppointmentFind_Find))
      
      RemoveHoverGadget(GadgetID(#Gadget_AppointmentFind_Exit))
      
      ;--------------------------------------------------------------------------------------------
      ; Setup module
      ;--------------------------------------------------------------------------------------------
      
    Case  #Window_AppointmentSetup
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      RemoveHoverGadget(GadgetID(#Gadget_AppointmentSetup_Save))
      
      RemoveHoverGadget(GadgetID(#Gadget_AppointmentSetup_Exit))
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Case  #Window_AppointmentArchive
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      RemoveHoverGadget(GadgetID(#Gadget_AppointmentArchive_Restore))
      
      RemoveHoverGadget(GadgetID(#Gadget_AppointmentArchive_Delete))
      
      RemoveHoverGadget(GadgetID(#Gadget_AppointmentArchive_Find))
      
      RemoveHoverGadget(GadgetID(#Gadget_AppointmentArchive_Help))
      
      RemoveHoverGadget(GadgetID(#Gadget_AppointmentArchive_Print))
      
      RemoveHoverGadget(GadgetID(#Gadget_AppointmentArchive_Exit))
        
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
  EndSelect
  
  ;------------------------------------------------------------------------------------------------
  ; Close the form window if it is not the master window
  ;------------------------------------------------------------------------------------------------
  
  CloseWindow(Window.i)

  ;------------------------------------------------------------------------------------------------
  ; Tell the user what just happened
  ;------------------------------------------------------------------------------------------------
  
  SetInfoBarArea("Headings",  "Info", #InfoStringWindowClosed + " (" + Program\LastWindow + ")")
  
  ;------------------------------------------------------------------------------------------------
  ; Zero certain variables not from the main window when they are closed
  ;------------------------------------------------------------------------------------------------

  If Window.i <> #Window_AppointmentMuncher

    ;----------------------------------------------------------------------------------------------
    ; Clear necessary variables
    ;----------------------------------------------------------------------------------------------
  
    Program\WindowMutex     =  0                                                                    ; Make sure other windows can open now  
    
    Program\DontCheck       =  0                                                                    ; Make sure that timed appointment check won't clash with other tasks
    
    Program\CurrentLine     = -1                                                                    ; Make sure no line can be selected accidentally
  
    Program\CurrentRecord   = ""                                                                    ; Nullify the current record number to avoid mistakes
    
    Program\LastWindow      = ""                                                                    ; Clear last used windows state
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------

  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; Refocus on main window and current record when data window is closed
  ;------------------------------------------------------------------------------------------------
  
  If Window.i <> #Window_AppointmentMuncher
       
    DisableWindow(#Window_AppointmentMuncher, #False)
    
    SetActiveWindow(#Window_AppointmentMuncher)
    
    SetActiveGadget(#Gadget_AppointmentMuncher_Appointments)

    SetGadgetState(#Gadget_AppointmentMuncher_Appointments, FocusLine.i)
      
  EndIf
    
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------

EndProcedure


; IDE Options = PureBasic 5.23 LTS (Windows - x86)
; CursorPosition = 44
; FirstLine = 42
; Folding = -
; EnableXP