﻿;============================================================================================================================================================
; Read the program toggles and search options from the database
;============================================================================================================================================================

Procedure ReadProgramOptions()
  
  ;------------------------------------------------------------------------------------------------
  ;
  ;------------------------------------------------------------------------------------------------
  
  QueryString.s = "SELECT * FROM Setup WHERE SetupRecord = '1'"
  
  ;------------------------------------------------------------------------------------------------
  ;
  ;------------------------------------------------------------------------------------------------
  
  If DatabaseQuery(Program\DatabaseHandle, QueryString.s)
    
    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------
    
    While NextDatabaseRow(Program\DatabaseHandle)
      
      ;--------------------------------------------------------------------------------------------
      ; Toggle-enabled options
      ;--------------------------------------------------------------------------------------------
      
      Setup\TitleClock      =       Val(GetDatabaseString(Program\DatabaseHandle,  0)) ; 1 or 0
      
      Setup\StickyWindow    =       Val(GetDatabaseString(Program\DatabaseHandle,  1)) ; 1 or 0
      
      Setup\ToolTips        =       Val(GetDatabaseString(Program\DatabaseHandle,  2)) ; 1 or 0
      
      Setup\ScreenSnap      =       Val(GetDatabaseString(Program\DatabaseHandle,  3)) ; 1 or 0
      
      Setup\AutoArchive     =       Val(GetDatabaseString(Program\DatabaseHandle,  4)) ; 1 or 0
      
      Setup\EmailAlarm      =       Val(GetDatabaseString(Program\DatabaseHandle,  5)) ; 1 or 0
      
      ;--------------------------------------------------------------------------------------------
      ; Standard options
      ;--------------------------------------------------------------------------------------------
      
      Setup\StartupDates    =       Val(GetDatabaseString(Program\DatabaseHandle,  6)) ; All, Active, etc
      
      Setup\SnoozePeriod    =       Val(GetDatabaseString(Program\DatabaseHandle,  7)) ; Off, 5 minutes etc
      
      Setup\AlarmSound      =       Val(GetDatabaseString(Program\DatabaseHandle,  8)) ; Siren.ogg??
      
      Setup\LastSearch      = KillQuote(GetDatabaseString(Program\DatabaseHandle,  9)) ; 'Doctor' etc
      
      ;--------------------------------------------------------------------------------------------
      ; For the sending of emails with alarm details
      ;--------------------------------------------------------------------------------------------
      
      Setup\ServerName      = KillQuote(GetDatabaseString(Program\DatabaseHandle, 10)) ; 
      
      Setup\PortNumber      = KillQuote(GetDatabaseString(Program\DatabaseHandle, 11)) ; 
      
      Setup\UserName        = KillQuote(GetDatabaseString(Program\DatabaseHandle, 12)) ; 
      
      Setup\Password        = KillQuote(GetDatabaseString(Program\DatabaseHandle, 13)) ; 
      
      Setup\NeedSsl         = KillQuote(GetDatabaseString(Program\DatabaseHandle, 14)) ; 
      
      Setup\EmailAddress    = KillQuote(GetDatabaseString(Program\DatabaseHandle, 15)) ; 

      ;--------------------------------------------------------------------------------------------
      ;
      ;--------------------------------------------------------------------------------------------
      
    Wend
    
    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------
    
    FinishDatabaseQuery(Program\DatabaseHandle)
    
    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings",  "Error",  #InfoStringQueryFailed + DatabaseError(), "ReadProgramOptions")
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ;
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.23 LTS (Windows - x86)
; CursorPosition = 41
; FirstLine = 17
; Folding = -
; EnableXP