﻿;==========================================================================================================================================================
; Send messages and error reports to the fake status bar area
;==========================================================================================================================================================

Procedure SetInfoBarArea(FieldName.s, FieldStatus.s, MessageContent.s = "0", ModuleName.s = "")
  
  ;------------------------------------------------------------------------------------------------
  ; Select the name of the field to put our heading string
  ;------------------------------------------------------------------------------------------------
  
  If FieldStatus.s = "Error"
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If ListSize(ErrorString())  >= 50
      
      WriteErrorLog()
      
      ClearList(ErrorString())
      
    Else
      
      ;--------------------------------------------------------------------------------------------
      ; Error list size isn't big enough to write to yet so we can add another element
      ;--------------------------------------------------------------------------------------------
      
      If AddElement(ErrorString())  <> 0
        
        ErrorString()\ModuleName   = ModuleName.s
        
        ErrorString()\ErrorMessage = Message.s  
        
      Else
        
        MessageRequester("Error log problem", "Cannot add a new message to the system error log!", #PB_MessageRequester_Ok)
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    ; Field status is not error so there is nothing to write
    
  EndIf
        
  ;------------------------------------------------------------------------------------------------
  ; Select the name of the field to put our heading string
  ;------------------------------------------------------------------------------------------------
  
  Select FieldName.s
      
    ;----------------------------------------------------------------------------------------------
    ; Select the correct heading by the status field
    ;----------------------------------------------------------------------------------------------
    
    Case "Headings"
    
      ;--------------------------------------------------------------------------------------------
      ; This is the field status heading and message
      ;--------------------------------------------------------------------------------------------
      
      Select FieldStatus.s
          
        Case "Welcome"
          
          MessageHeader.s = "Welcome"
          
          Colour.i        = $DB3D24
          
        Case "Info"
          
          MessageHeader.s = "Information"
          
          Colour.i        = $DB3D24
          
        Case "Warn"
          
          MessageHeader.s = "Warning"
          
          Colour.i        = $7D1F82
          
        Case "Error"
          
          MessageHeader.s = "Error"
          
          Colour.i        = $0402FB
          
        Case "Appoint"
          
          MessageHeader.s = "Appointment"
          
          Colour.i        = $002200
          
      EndSelect
      
      ;--------------------------------------------------------------------------------------------
      ; Send all the strings to the fake status bar area
      ;--------------------------------------------------------------------------------------------
      
      SetGadgetText(#Gadget_AppointmentMuncher_tStatus,     MessageHeader.s)
      
      SetGadgetColor(#Gadget_AppointmentMuncher_tStatus,    #PB_Gadget_FrontColor, Colour.i)
      
      SetGadgetText(#Gadget_AppointmentMuncher_tMessage,    MessageContent.s)
      
      SetGadgetColor(#Gadget_AppointmentMuncher_tMessage,   #PB_Gadget_FrontColor, Colour.i)
      
      ;--------------------------------------------------------------------------------------------
      ; This is the current record number field
      ;--------------------------------------------------------------------------------------------
      
    Case "Number"
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      SetGadgetText(#Gadget_AppointmentMuncher_tCurrent, "Record " + MessageContent.s)
      
      ;--------------------------------------------------------------------------------------------
      ; This is the number of displayed records field
      ;--------------------------------------------------------------------------------------------
      
    Case "Records"
      
      ;--------------------------------------------------------------------------------------------
      ; Figure out the correct spelling for the record field for singles or multiples
      ;--------------------------------------------------------------------------------------------
      
      If Val(MessageContent.s) = 0
        
        RecordHeader.s = "Items"
        
      ElseIf Val(MessageContent.s)  = 1
        
        RecordHeader.s = "Item"
        
      ElseIf Val(MessageContent.s) >= 2
        
        RecordHeader.s = "Items"
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; Set the record number details in the fake status bar area
      ;--------------------------------------------------------------------------------------------
      
      SetGadgetText(#Gadget_AppointmentMuncher_tRecord, MessageContent.s + " " + RecordHeader.s)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
  EndSelect
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure


; IDE Options = PureBasic 5.22 LTS (Windows - x86)
; Folding = -
; EnableXP