﻿;==========================================================================================================================================================
; Save all the setup variables to database
;==========================================================================================================================================================

Procedure SetupAppointmentsSave()
  
  ;------------------------------------------------------------------------------------------------
  ; Toggles
  ;------------------------------------------------------------------------------------------------   
  
  Setup\TitleClock      =          GetGadgetState(#Gadget_AppointmentSetup_Titleclock)       ; 1 or 0
  
  Setup\StickyWindow    =          GetGadgetState(#Gadget_AppointmentSetup_Stickywindow)     ; 1 or 0
  
  Setup\ToolTips        =          GetGadgetState(#Gadget_AppointmentSetup_Tooltips)         ; 1 or 0
  
  Setup\ScreenSnap      =          GetGadgetState(#Gadget_AppointmentSetup_Screensnap)       ; 1 or 0
  
  Setup\AutoArchive     =          GetGadgetState(#Gadget_AppointmentSetup_AutoArchive)      ; 1 or 0
  
  Setup\EmailAlarm      =          GetGadgetState(#Gadget_AppointmentSetup_EmailAlarm)       ; 1 or 0
  
  ;--------------------------------------------------------------------------------------------
  ; Options
  ;--------------------------------------------------------------------------------------------
  
  Setup\StartupDates    =          GetGadgetState(#Gadget_AppointmentSetup_StartupDates)     ; All, Active, etc (0 to 6)
  
  Setup\SnoozePeriod    =          GetGadgetState(#Gadget_AppointmentSetup_SnoozePeriod)     ; Off, 5 minutes etc
  
  Setup\AlarmSound      =          GetGadgetState(#Gadget_AppointmentSetup_AlarmSound)       ; Alarm sound used
  
  Setup\LastSearch      =  RepQuote(GetGadgetText(#Gadget_AppointmentSetup_LastSearch))      ; 'Doctor' etc
  
  ;------------------------------------------------------------------------------------------------
  ; Strings
  ;------------------------------------------------------------------------------------------------
      
  Setup\ServerName      =  RepQuote(GetGadgetText(#Gadget_AppointmentSetup_ServerName))      ; 
  
  Setup\PortNumber      =  RepQuote(GetGadgetText(#Gadget_AppointmentSetup_PortNumber))      ; 
  
  Setup\UserName        =  RepQuote(GetGadgetText(#Gadget_AppointmentSetup_UserName))        ; 
  
  Setup\Password        =  RepQuote(GetGadgetText(#Gadget_AppointmentSetup_Password))        ; 
  
  Setup\NeedSsl         =  RepQuote(GetGadgetText(#Gadget_AppointmentSetup_NeedSsl))         ; 
  
  Setup\EmailAddress    =  RepQuote(GetGadgetText(#Gadget_AppointmentSetup_EmailAddress))    ; 
  
  ;------------------------------------------------------------------------------------------------
  ; Database update
  ;------------------------------------------------------------------------------------------------
  
  QueryString.s = "UPDATE Setup SET"
  
  QueryString.s + "   TitleClock = '"     + Str(Setup\TitleClock)   + "', StickyWindow = '"   + Str(Setup\StickyWindow)
  
  QueryString.s + "', ToolTips = '"       + Str(Setup\ToolTips)     + "', ScreenSnap = '"     + Str(Setup\ScreenSnap)
  
  QueryString.s + "', AutoArchive = '"    + Str(Setup\AutoArchive)  + "', EmailAlarm = '"     + Str(Setup\EmailAlarm)
  
  QueryString.s + "', StartupDates = '"   + Str(Setup\StartupDates) + "', SnoozePeriod = '"   + Str(Setup\SnoozePeriod)
  
  QueryString.s + "', AlarmSound = '"     + Str(Setup\AlarmSound)   + "', LastSearch = '"     +     Setup\LastSearch
  
  QueryString.s + "', ServerName = '"     +     Setup\ServerName    + "', PortNumber = '"     +     Setup\PortNumber
  
  QueryString.s + "', UserName = '"       +     Setup\UserName      + "', Password = '"       +     Setup\Password
  
  QueryString.s + "', NeedSsl = '"        +     Setup\NeedSsl       + "', EmailAddress = '"   +     Setup\EmailAddress
  
  QueryString.s + "' Where SetupRecord = '1'" 
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If DatabaseUpdate(Program\DatabaseHandle, QueryString.s)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If Setup\TitleClock = 0
      
      Setup\TitleClock  = 1
      
    ElseIf  Setup\TitleClock = 1
      
      Setup\TitleClock = 0
      
    EndIf
    
    If Setup\StickyWindow = 0
      
      Setup\StickyWindow  = 1
      
    ElseIf  Setup\StickyWindow = 1
      
      Setup\StickyWindow = 0
      
    EndIf
    
    If Setup\ToolTips = 0
      
      Setup\ToolTips  = 1
      
    ElseIf  Setup\ToolTips = 1
      
      Setup\ToolTips = 0
      
    EndIf
    
    If Setup\ScreenSnap = 0
      
      Setup\ScreenSnap  = 1
      
    ElseIf  Setup\ScreenSnap = 1
      
      Setup\ScreenSnap = 0
      
    EndIf
    
    If Setup\EmailAlarm = 0
      
      Setup\EmailAlarm  = 1
      
    ElseIf  Setup\EmailAlarm = 1
      
      Setup\EmailAlarm = 0
      
    EndIf
    
    If Setup\AutoArchive = 0
      
      Setup\AutoArchive  = 1
      
    ElseIf  Setup\AutoArchive = 1
      
      Setup\AutoArchive = 0
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    ToggleBalloonToolTips()
    
    ToggleStickyWindow()
    
    ToggleTitleClock()
    
    ToggleScreenSnap()
    
    ToggleEmailAlarm()

    ToggleAutoArchive()
    
    ;----------------------------------------------------------------------------------------------
    ; Set the option gadget to show the appointment level you want to show
    ;----------------------------------------------------------------------------------------------

    If Setup\StartupDates
      
      Select Setup\StartupDates
          
        Case 0  : GadgetNumber.i = #Gadget_AppointmentMuncher_oAll
          
        Case 1  : GadgetNumber.i = #Gadget_AppointmentMuncher_oActive
          
        Case 2  : GadgetNumber.i = #Gadget_AppointmentMuncher_oPast
          
        Case 3  : GadgetNumber.i = #Gadget_AppointmentMuncher_oToday
          
        Case 4  : GadgetNumber.i = #Gadget_AppointmentMuncher_oFuture
          
        Case 5  : GadgetNumber.i = #Gadget_AppointmentMuncher_oFinished
          
        Case 6  : GadgetNumber.i = #Gadget_AppointmentMuncher_oDeleted
          
        Default
          
      EndSelect
      
      SetGadgetState(GadgetNumber.i, 1)
      
    Else
      
      SetGadgetState(#Gadget_AppointmentMuncher_oAll, 1)
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    PostEvent(#PB_Event_Gadget, #Window_AppointmentMuncher, GadgetNumber.i, #PB_EventType_Change)
    
    ;------------------------------------------------------------------------------------------------
    ; Check if the alarm routine needs to be run. The on or off state and value is determined at
    ; runtime by a setup table value. PostEvent makes sure it is then checked
    ;------------------------------------------------------------------------------------------------
    
    If Setup\SnoozePeriod
      
      SetGadgetState(#Gadget_AppointmentMuncher_SnoozePeriod, Setup\SnoozePeriod)
      
      PostEvent(#PB_Event_Gadget, #Window_AppointmentMuncher, #Gadget_AppointmentMuncher_SnoozePeriod, #PB_EventType_Change)
      
    Else
      
      SetGadgetState(#Gadget_AppointmentMuncher_SnoozePeriod, 1)
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    SetGadgetText(#Gadget_AppointmentMuncher_Search, Setup\LastSearch)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else

    SetInfoBarArea("Headings",  "Error", #InfoStringUpdateFailed + DatabaseError())
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  CloseMyWindow(#Window_AppointmentSetup)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.23 LTS (Windows - x86)
; CursorPosition = 158
; FirstLine = 140
; Folding = -
; EnableXP