﻿;========================================================================================================================================
; Permanently clean appointments marked deleted from the database
;========================================================================================================================================

Procedure CleanAppointments()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
    
  If MessageRequester("Clean deleted records", "Permanently remove deleted records?."  + #CRLF$ + #CRLF$ + "Only non protected records will be removed.", #PB_MessageRequester_YesNo)  = #PB_MessageRequester_Yes
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    QueryString.s = "DELETE FROM Appointments "
    
    QueryString.s + "WHERE appDeleted = '1' "
    
    QueryString.s + "AND appProtect = '0'"
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If DatabaseUpdate(Program\DatabaseHandle, QueryString.s)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      NumberOfItems.i = CountGadgetItems(#Gadget_AppointmentMuncher_Appointments)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      If NumberOfItems.i <> 0
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        For ItemList.i = NumberOfItems.i To 0 Step -1
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          If GetGadgetItemState(#Gadget_AppointmentMuncher_Appointments, ItemList.i) & #PB_ListIcon_Selected
            
            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
            appDeleted.s = GetGadgetItemText(#Gadget_AppointmentMuncher_Appointments, ItemList.i, Program\DeletedColumn)
            
            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
            If appDeleted <> "1"
              
              RemoveGadgetItem(#Gadget_AppointmentMuncher_Appointments, ItemList.i)
              
            Else
              
              SetInfoBarArea("Headings",  "Warn",  #InfoStringCannotRemove)
              
            EndIf
            
            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
          Else
            
            ; SetInfoBarArea("Headings", "Warn", #InfoStringNotSelected)
            
          EndIf
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
        Next ItemList.i
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      Else
        
        SetInfoBarArea("Headings", "Warn", #InfoStringNoneToRemove)
        
      EndIf

      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      SetInfoBarArea("Headings", "Info", #InfoStringRemovedDeleted)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Else
      
      SetInfoBarArea("Headings", "Error", #InfoStringUpdateFailed + DatabaseError(), "CleanAppointments")
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
  
  EndIf

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.23 LTS (Windows - x86)
; CursorPosition = 110
; Folding = -
; EnableXP