﻿;==========================================================================================================================================================
; Copy highlighted appointment to the system clipboard
;==========================================================================================================================================================

Procedure CopySelectedAppointments()
  
  ;------------------------------------------------------------------------------------------------
  ; Check if the alarm checker is running first
  ;------------------------------------------------------------------------------------------------
  
  If Program\DontCheck <> 1
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    Program\DontCheck = 1
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    NumberOfItems.i = CountGadgetItems(#Gadget_AppointmentMuncher_Appointments)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If NumberOfItems.i <> 0
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      For ItemList.i = 0 To NumberOfItems.i - 1
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        If GetGadgetItemState(#Gadget_AppointmentMuncher_Appointments, ItemList.i) & #PB_ListIcon_Selected
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          appDeleted.s = GetGadgetItemText(#Gadget_AppointmentMuncher_Appointments, ItemList.i, Program\DeletedColumn)
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          If appDeleted <> "1"
            
            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
            CopyCounter.i + 1
            
            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
            RecordNumber.s = GetGadgetItemText(#Gadget_AppointmentMuncher_Appointments, ItemList.i, Program\RecordColumn)
            
            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
            QueryString.s = "SELECT * FROM Appointments "
            
            QueryString.s + "WHERE appRecord = '" + RecordNumber.s + "' "
            
            QueryString.s + "AND appDeleted <> '1'"
            
            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
            If DatabaseQuery(Program\DatabaseHandle, QueryString.s)
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
              While NextDatabaseRow(Program\DatabaseHandle)
                
                ;----------------------------------------------------------------------------------
                ; 
                ;----------------------------------------------------------------------------------
                
                MasterString.s + FormatField("Appointment name",  25) + KillQuote(GetDatabaseString(Program\DatabaseHandle,  0))               + #CRLF$
                
                MasterString.s + FormatField("Date",              25) +   IsoDate(GetDatabaseString(Program\DatabaseHandle,  1), "NormalDate") + #CRLF$
                
                MasterString.s + FormatField("Time",              25) + KillQuote(GetDatabaseString(Program\DatabaseHandle,  2))               + #CRLF$
                
                MasterString.s + FormatField("Alarm",             25) +   IsoDate(GetDatabaseString(Program\DatabaseHandle,  3), "NormalDate") + #CRLF$
                
                MasterString.s + FormatField("Repeat",            25) + KillQuote(GetDatabaseString(Program\DatabaseHandle,  4))               + #CRLF$
                
                MasterString.s + FormatField("Protect",           25) + KillQuote(GetDatabaseString(Program\DatabaseHandle,  5))               + #CRLF$
                  
                MasterString.s + FormatField("Category",          25) + KillQuote(GetDatabaseString(Program\DatabaseHandle,  6))               + #CRLF$
                
                MasterString.s + FormatField("Status",            25) + KillQuote(GetDatabaseString(Program\DatabaseHandle,  7))               + #CRLF$
                
                MasterTemp.s   + FormatField("Comment",           25) + KillQuote(GetDatabaseString(Program\DatabaseHandle,  8))               + #CRLF$
                
                MasterTemp.s   + FormatField("Archived",          25) + KillQuote(GetDatabaseString(Program\DatabaseHandle,  9))               + #CRLF$
                
                MasterTemp.s   + FormatField("Emailed",           25) + KillQuote(GetDatabaseString(Program\DatabaseHandle, 10))               + #CRLF$
                
                MasterTemp.s   + FormatField("Sound",             25) + KillQuote(GetDatabaseString(Program\DatabaseHandle, 11))               + #CRLF$
                
                MasterString.s + FormatField("Deleted",           25) + KillQuote(GetDatabaseString(Program\DatabaseHandle, 12))               + #CRLF$
                
                MasterString.s + FormatField("Record",            25) + KillQuote(GetDatabaseString(Program\DatabaseHandle, 13))               + #CRLF$
                
                MasterString.s + "------------------------------------------------------------------------------"                              + #CRLF$
                
                ;----------------------------------------------------------------------------------
                ; 
                ;----------------------------------------------------------------------------------
    
              Wend
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
              FinishDatabaseQuery(Program\DatabaseHandle)
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
            Else
              
              SetInfoBarArea("Headings", "Warn", #InfoStringQueryFailed + DatabaseError(), "CopySelectedAppointments")
              
            EndIf
            
            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
          Else
            
            SetInfoBarArea("Headings",  "Warn",  #InfoStringCannotCopy)
            
          EndIf
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
;       Else
          
;         SetInfoBarArea("Headings", "Warn", #InfoStringNotSelected)
          
        EndIf
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      Next ItemList.i
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      If CopyCounter.i <> 0
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        SetClipboardText(MasterString.s)
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        SetInfoBarArea("Headings", "Info", Str(CopyCounter.i) + #InfoStringCopyWorked)
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      Else  
        
        SetInfoBarArea("Headings", "Error", #InfoStringFailedCopy, "CopySelectedAppointments")
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Else
      
      SetInfoBarArea("Headings", "Warn", #InfoStringNoneToCopy)
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    Program\DontCheck = 0
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
      
    SetInfoBarArea("Headings",  "Warn",  #InfoStringAlarmRunning)
      
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure


; IDE Options = PureBasic 5.23 LTS (Windows - x86)
; CursorPosition = 120
; FirstLine = 96
; Folding = -
; EnableXP