﻿;==========================================================================================================================================================
; Edit the selected appointment
;==========================================================================================================================================================

Procedure EditSelectedAppointment()
  
  ;------------------------------------------------------------------------------------------------
  ; Check if the alarm checker is running first
  ;------------------------------------------------------------------------------------------------
  
  If Program\DontCheck <> 1
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    Program\CurrentLine = GetGadgetState(#Gadget_AppointmentMuncher_Appointments)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If Program\CurrentLine <> -1
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      Program\CurrentRecord = GetGadgetItemText(#Gadget_AppointmentMuncher_Appointments, Program\CurrentLine, Program\RecordColumn)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      appDeleted.s = GetGadgetItemText(#Gadget_AppointmentMuncher_Appointments, Program\CurrentLine, Program\DeletedColumn)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      If appDeleted.s <> "1"
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        If Program\CurrentRecord <> ""
        
          ;----------------------------------------------------------------------------------------
          ; Check if a previous window is open
          ;----------------------------------------------------------------------------------------
          
          If Program\WindowMutex <> 1
            
            ;--------------------------------------------------------------------------------------
            ; Try to open the data window
            ;--------------------------------------------------------------------------------------
            
            If Window_AppointmentData()
              
              ;------------------------------------------------------------------------------------
              ; Prevent user input on the main window
              ;------------------------------------------------------------------------------------
              
              DisableWindow(#Window_AppointmentMuncher, #True)
              
              ;------------------------------------------------------------------------------------
              ; Add the various keyboard shortcuts
              ;------------------------------------------------------------------------------------
              
              AddKeyboardShortcut(#Window_AppointmentData, #PB_Shortcut_Escape, #Shortcut_AppointmentData_Escape)
              
              ;------------------------------------------------------------------------------------
              ; Warn other components a window is open and not to attempt to open another
              ;------------------------------------------------------------------------------------
              
              Program\WindowMutex = 1
              
              ;------------------------------------------------------------------------------------
              ; Warn other components that the alarm checker should not be run right now
              ;------------------------------------------------------------------------------------
              
              Program\DontCheck = 1
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
              AddHoverGadget(GadgetID(#Gadget_AppointmentData_Save))
              
              AddHoverGadget(GadgetID(#Gadget_AppointmentData_Exit))
              
              ;------------------------------------------------------------------------------------
              ; Remove theme support from the comment box or it retains a border even when API removed
              ;------------------------------------------------------------------------------------
              
              SetWindowTheme_(GadgetID(#Gadget_AppointmentData_Comment),   @null.w, @null.w)
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
              Restore AlarmRepeats
              
              While TempCategory.s <> "_EndAlarmRepeats_"
                
                Read.s TempCategory.s
                
                If TempCategory.s <> "_EndAlarmRepeats_"
                  
                  AddGadgetItem(#Gadget_AppointmentData_Repeat, -1, TempCategory.s, ImageID(#Repeatalarm))
                  
                EndIf
                
              Wend
              
              TempCategory.s    = "<>"
              
              TempIconNumber.s  = "<>"
              
              SetGadgetState(#Gadget_AppointmentData_Repeat, 0)
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
              AddGadgetItem(#Gadget_AppointmentData_Protected, -1, "Unlocked",  ImageID(#Unlocked))
              
              AddGadgetItem(#Gadget_AppointmentData_Protected, -1, "Locked",    ImageID(#Locked))
              
              SetGadgetState(#Gadget_AppointmentData_Protected, 0)
              
              ;------------------------------------------------------------------------------------
              ; Setup the category items
              ;------------------------------------------------------------------------------------
              
              Restore BeginCategories
              
              CategoryStartValue.i = #CatUnknown
              
              While TempCategory.s <> "_EndCategories_"
                
                Read.s TempCategory.s
                
                Read.s TempIconNumber.s
                
                If TempCategory.s <> "_EndCategories_"
                  
                  AddGadgetItem(#Gadget_AppointmentData_Category, -1, TempCategory.s, ImageID(CategoryStartValue.i))
                  
                  CategoryStartValue.i + 1
                  
                EndIf
                
              Wend
              
              TempCategory.s    = "<>"
              
              TempIconNumber.s  = "<>"
              
              ;------------------------------------------------------------------------------------
              ; Add the possible status conditions to the status chooser
              ;------------------------------------------------------------------------------------
              
              AddGadgetItem(#Gadget_AppointmentData_Itemstatus, -1, "Active appointment",   ImageID(#StatusActive))
              
              AddGadgetItem(#Gadget_AppointmentData_Itemstatus, -1, "Finished appointment", ImageID(#StatusFinished))
              
              ;------------------------------------------------------------------------------------
              ; Repeat
              ;------------------------------------------------------------------------------------
              
;               Restore AlarmSounds
;               While TempCategory.s <> "_EndAlarmSounds_"
;                 Read.s TempCategory.s
;                 If TempCategory.s <> "_EndAlarmSounds_"
;                   AddGadgetItem(#Gadget_AppointmentData_AlarmSound, -1, TempCategory.s, ImageID(#Alarmsound))
;                 EndIf
;               Wend
;               TempCategory.s    = "<>"
;               TempIconNumber.s  = "<>"
;               SetGadgetState(#Gadget_AppointmentData_AlarmSound, 1)

              ;------------------------------------------------------------------------------------
              ; Set the common window and statusbar message
              ;------------------------------------------------------------------------------------
              
              Message.s = "Edit Old Appointment"
              
              ;------------------------------------------------------------------------------------
              ; Use the common message as a window identifier
              ;------------------------------------------------------------------------------------
              
              Program\LastWindow = Message.s
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
              QueryString.s = "SELECT * FROM Appointments "
              
              QueryString.s + "WHERE appRecord = '" + Program\CurrentRecord + "'"
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
              With Appointment
                
                ;----------------------------------------------------------------------------------
                ; 
                ;----------------------------------------------------------------------------------
                
                If DatabaseQuery(Program\DatabaseHandle,  QueryString.s)
                  
                  ;--------------------------------------------------------------------------------
                  ; 
                  ;--------------------------------------------------------------------------------
                  
                  While NextDatabaseRow(Program\DatabaseHandle)
                    
                    ;------------------------------------------------------------------------------
                    ; 
                    ;------------------------------------------------------------------------------
                    
                    \appName        = KillQuote(GetDatabaseString(Program\DatabaseHandle,   0))
                    
                    \appDate        =    IsoDate(GetDatabaseString(Program\DatabaseHandle,  1), "NormalDate")
                    
                    \appTime        =            GetDatabaseString(Program\DatabaseHandle,  2) 
                     
                    \appAlarm       =    IsoDate(GetDatabaseString(Program\DatabaseHandle,  3), "NormalDate")
                    
                    \appRepeat      =            GetDatabaseString(Program\DatabaseHandle,  4) 
                    
                    \appProtect     =            GetDatabaseString(Program\DatabaseHandle,  5) 
                    
                    \appCategory    =  KillQuote(GetDatabaseString(Program\DatabaseHandle,  6))
                    
                    \appStatus      =  KillQuote(GetDatabaseString(Program\DatabaseHandle,  7))
                    
                    \appComment     =  KillQuote(GetDatabaseString(Program\DatabaseHandle,  8))
                    
                    \appArchived    =  KillQuote(GetDatabaseString(Program\DatabaseHandle,  9))
                    
                    \appEmailed     =  KillQuote(GetDatabaseString(Program\DatabaseHandle, 10))
                    
                    \appSound       =  KillQuote(GetDatabaseString(Program\DatabaseHandle, 11))
                    
                    \appDeleted     =            GetDatabaseString(Program\DatabaseHandle, 12) 
                    
                    \appRecord      =            GetDatabaseString(Program\DatabaseHandle, 13) 
                    
                    ;------------------------------------------------------------------------------
                    ; 
                    ;------------------------------------------------------------------------------
                    
                  Wend
                  
                  ;--------------------------------------------------------------------------------
                  ; 
                  ;--------------------------------------------------------------------------------
                  
                  FinishDatabaseQuery(Program\DatabaseHandle)
                  
                  ;--------------------------------------------------------------------------------
                  ; 
                  ;--------------------------------------------------------------------------------
                  
                Else
                  
                  SetInfoBarArea("Headings", "Error", #InfoStringQueryFailed + DatabaseError(), "EditSelectedAppointment")
                  
                EndIf
                
                ;----------------------------------------------------------------------------------
                ; 
                ;----------------------------------------------------------------------------------
             
                SetGadgetText(#Gadget_AppointmentData_Itemname,                                   \appName)
                
                SetGadgetState(#Gadget_AppointmentData_cDatepick,     ParseDate("%dd/%mm/%yyyy",  \appDate))
                
                SetGadgetItemState(#Gadget_AppointmentData_cDatepick, ParseDate("%dd/%mm/%yyyy",  \appDate), #PB_Calendar_Bold)
                
                SetGadgetText(#Gadget_AppointmentData_Itemdate,                                   \appDate)
                
                SetGadgetState(#Gadget_AppointmentData_Timepick,      ParseDate("%hh:%ii",        \appTime))
                
                SetGadgetState(#Gadget_AppointmentData_Alarmpick,     ParseDate("%dd/%mm/%yyyy",  \appAlarm))
                
                SetGadgetState(#Gadget_AppointmentData_Repeat,                                Val(\appRepeat))
                
                SetGadgetState(#Gadget_AppointmentData_Protected,                             Val(\appProtect))
                
                SetGadgetText(#Gadget_AppointmentData_Category,                                   \appCategory)
                
                SetGadgetText(#Gadget_AppointmentData_Itemstatus,                                 \appStatus)
                
                SetGadgetText(#Gadget_AppointmentData_Comment,                                    \appComment)
                
                SetGadgetText(#Gadget_AppointmentData_Archived,                                   \appArchived)
                
                SetGadgetText(#Gadget_AppointmentData_Emailed,                                    \appEmailed)
                
                SetGadgetText(#Gadget_AppointmentData_Recordnumber,                               \appRecord)
                
                ;------------------------------------------------------------------------------------
                ; Set the window title with the common message and next record number
                ;------------------------------------------------------------------------------------
                
                SetWindowTitle(#Window_AppointmentData, Message.s + "   --   Record number: " + \appRecord)
                
                ;------------------------------------------------------------------------------------
                ; Set the current operation details on the the main window status bar
                ;------------------------------------------------------------------------------------
                
                SetInfoBarArea("Headings",  "Info",     Message.s + "   --   Record number: " + \appRecord)
                
                ;------------------------------------------------------------------------------------
                ; Set focus on the appointment name field
                ;------------------------------------------------------------------------------------
                
                SetActiveGadget(#Gadget_AppointmentData_Itemname)
                
                ;----------------------------------------------------------------------------------
                ; 
                ;----------------------------------------------------------------------------------
              
              EndWith
              
              ;----------------------------------------------------------------------------------
              ; 
              ;----------------------------------------------------------------------------------
              
            Else
              
              SetInfoBarArea("Headings",  "Error",  #InfoStringCannotOpen, "EditSelectedAppointment")
              
            EndIf
            
            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
          Else
            
            SetInfoBarArea("Headings",  "Warn",  #InfoStringWindowOpen)
            
          EndIf
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
        Else
          
          SetInfoBarArea("Headings",  "Error",  #InfoStringNoRecord, "EditSelectedAppointment")
          
        EndIf
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      Else
        
        SetInfoBarArea("Headings",  "Warn",  #InfoStringCannotEdit)
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Else
      
      ; SetInfoBarArea("Headings", "Info",  #InfoStringNotSelected)
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings",  "Warn",  #InfoStringAlarmRunning)
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure


; IDE Options = PureBasic 5.23 LTS (Windows - x86)
; CursorPosition = 301
; FirstLine = 280
; Folding = -
; EnableXP
; HideErrorLog