﻿;==========================================================================================================================================================
; Seach for appointmnents inside a specific choice
;==========================================================================================================================================================

Procedure SearchAppointments()
  
  ;------------------------------------------------------------------------------------------------
  ; Check if the alarm checker is running first
  ;------------------------------------------------------------------------------------------------
  
  If Program\DontCheck <> 1
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    Program\DontCheck = 1
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    SearchText.s = GetGadgetText(#Gadget_AppointmentMuncher_Search)
    
    ;----------------------------------------------------------------------------------------------
    ; Grab the last search string used
    ;----------------------------------------------------------------------------------------------
    
    Setup\LastSearch      =  RepQuote(SearchText.s)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    ClearGadgetItems(#Gadget_AppointmentMuncher_Appointments)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    SetGadgetText(#Gadget_AppointmentMuncher_Search, "")
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If GetGadgetState(#Gadget_AppointmentMuncher_oAll) = 1
      
      QueryAddon.s  = ""
      
;     QueryAddon.s  = " AND appDeleted <> '1'"
      
    EndIf
    
    If GetGadgetState(#Gadget_AppointmentMuncher_oActive) = 1
      
      QueryAddon.s  = " AND appStatus = 'Active appointment' AND appDeleted <> '1' AND appProtect <> '1'"
      
    EndIf
    
    If GetGadgetState(#Gadget_AppointmentMuncher_oPast) = 1
      
      QueryAddon.s  = " AND appDate < '"  + Program\ISODate + "' AND appStatus <> 'Finished appointment' AND appDeleted <> '1' AND appProtect <> '1'"
      
    EndIf
    
    If GetGadgetState(#Gadget_AppointmentMuncher_oToday) = 1
      
      QueryAddon.s  = " AND appDate = '"  + Program\ISODate + "' AND appStatus <> 'Finished appointment' And appDeleted <> '1' AND appProtect <> '1'"
      
    EndIf
    
    If GetGadgetState(#Gadget_AppointmentMuncher_oFuture) = 1
      
      QueryAddon.s  = " AND appDate > '"  + Program\ISODate + "' AND appStatus <> 'Finished appointment' AND appDeleted <> '1' AND appProtect <> '1'"
      
    EndIf
    
    If GetGadgetState(#Gadget_AppointmentMuncher_oFinished) = 1
      
      QueryAddon.s = " AND appStatus = 'Finished appointment' AND appDeleted <> '1' AND appProtect <> '1'"
      
    EndIf
    
    If GetGadgetState(#Gadget_AppointmentMuncher_oDeleted) = 1
      
      QueryAddon.s = " AND appDeleted = '1'"
      
    EndIf
    
;     If GetGadgetState(#Gadget_AppointmentMuncher_oProtect) = 1
;       
;       QueryAddon.s = " AND appProtect <> '1'"
;       
;     EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    QueryString.s = "SELECT * FROM Appointments WHERE ("
    
    QueryString.s + " appName LIKE '%"            + SearchText.s + "%'"
    
    QueryString.s + " OR appDate LIKE '%"         + SearchText.s + "%'"
    
    QueryString.s + " OR appTime LIKE '%"         + SearchText.s + "%'"
    
    QueryString.s + " OR appAlarm LIKE '%"        + SearchText.s + "%'"
    
    QueryString.s + " OR appRepeat LIKE '%"       + SearchText.s + "%'"
    
    QueryString.s + " OR appProtect LIKE '%"      + SearchText.s + "%'"
    
    QueryString.s + " OR appCategory LIKE '%"     + SearchText.s + "%'"
    
    QueryString.s + " Or appStatus LIKE '%"       + SearchText.s + "%'"
    
    QueryString.s + " OR appComment LIKE '%"      + SearchText.s + "%'"
    
    QueryString.s + " OR appEmailed LIKE '%"      + SearchText.s + "%'"
    
    QueryString.s + " OR appArchived LIKE '%"     + SearchText.s + "%'"
    
    QueryString.s + " OR appSound LIKE '%"        + SearchText.s + "%'"
    
    QueryString.s + " OR appDeleted LIKE '%"      + SearchText.s + "%'"
    
    QueryString.s + " OR appRecord LIKE '%"       + SearchText.s + "%'"
    
    QueryString.s + ")"
    
    QueryString.s + QueryAddon.s
    
    QueryString.s + " ORDER BY appDate"
  
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    ItemCounter.i = 0
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    With Appointment
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      If DatabaseQuery(Program\DatabaseHandle,  QueryString.s)
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        While NextDatabaseRow(Program\DatabaseHandle)
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          \appName        = KillQuote(GetDatabaseString(Program\DatabaseHandle,   0))
          
          \appDate        =    IsoDate(GetDatabaseString(Program\DatabaseHandle,  1), "NormalDate")
          
          \appTime        =            GetDatabaseString(Program\DatabaseHandle,  2) 
           
          \appAlarm       =    IsoDate(GetDatabaseString(Program\DatabaseHandle,  3), "NormalDate")
          
          \appRepeat      =            GetDatabaseString(Program\DatabaseHandle,  4) 
          
          \appProtect     =            GetDatabaseString(Program\DatabaseHandle,  5) 
          
          \appCategory    =  KillQuote(GetDatabaseString(Program\DatabaseHandle,  6))
          
          \appStatus      =  KillQuote(GetDatabaseString(Program\DatabaseHandle,  7))
          
          \appComment     =  KillQuote(GetDatabaseString(Program\DatabaseHandle,  8))
          
          \appArchived    =  KillQuote(GetDatabaseString(Program\DatabaseHandle,  9))
          
          \appEmailed     =  KillQuote(GetDatabaseString(Program\DatabaseHandle, 10))
          
          \appSound       =  KillQuote(GetDatabaseString(Program\DatabaseHandle, 11))
          
          \appDeleted     =            GetDatabaseString(Program\DatabaseHandle, 12) 
          
          \appRecord      =            GetDatabaseString(Program\DatabaseHandle, 13) 
          
          ;----------------------------------------------------------------------------------------
          ; Now, off to the display routine. It must set icons, data and nicely formatted dates
          ;----------------------------------------------------------------------------------------
          
          DisplayAppointmentString(ItemCounter.i, "AddMode")
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          ItemCounter.i + 1
          
          ;----------------------------------------------------------------------------------------
          ; Tell the user what is going on in the status bar 
          ;----------------------------------------------------------------------------------------
          
          SetInfoBarArea("Headings", "Info",  "Showing: " + KillQuote(\appName))
          
          SetInfoBarArea("Records",  "",        Str(ItemCounter.i))
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          ClearStructure(@Appointment, AppointmentData)
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
        Wend
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        FinishDatabaseQuery(Program\DatabaseHandle)
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        If  CountGadgetItems(#Gadget_AppointmentMuncher_Appointments) <> 0
          
          SetGadgetState(#Gadget_AppointmentMuncher_Appointments, 0)
          
          PostEvent(#PB_Event_Gadget, #Window_AppointmentMuncher, #Gadget_AppointmentMuncher_Appointments, #PB_EventType_Change)
          
        Else
          
          ClearGadgetItems(#Gadget_AppointmentMuncher_Appointments)
          
          SetGadgetText(#Gadget_AppointmentMuncher_Repeat,   "")
          
          SetGadgetText(#Gadget_AppointmentMuncher_Protect,  "")
          
          SetGadgetText(#Gadget_AppointmentMuncher_Category, "")
          
          SetGadgetText(#Gadget_AppointmentMuncher_Status,   "")
          
          SetGadgetText(#Gadget_AppointmentMuncher_Comment,  "")
          
          ;----------------------------------------------------------------------------------------
          ; Tell the fake statusbar what appointment and record number this is
          ;----------------------------------------------------------------------------------------
          
          SetInfoBarArea("Headings", "Info", "No records found")
          
          SetInfoBarArea("Number",    "",    "?")
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
        EndIf
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      Else
        
        SetInfoBarArea("Headings", "Error", #InfoStringQueryFailed + DatabaseError(), "SearchAppointments")
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    EndWith
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    Program\DontCheck = 0
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
      
    SetInfoBarArea("Headings",  "Warn",  #InfoStringAlarmRunning)
      
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure


; IDE Options = PureBasic 5.23 LTS (Windows - x86)
; CursorPosition = 191
; FirstLine = 42
; Folding = -
; EnableXP