﻿;========================================================================================================================================
; Handle all list display jobs from add, edit, list, import modes etc
;========================================================================================================================================

Procedure DisplayListItem(LineNumber.i, DisplayMode.s)
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Select DisplayMode.s
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    Case  "AddMode"
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      AddGadgetItem(#Gadget_AppointmentMuncher_Appointments, -1, Appointment\appDate  + Chr(10) + Appointment\appRecord)
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
    Case  "EditMode"
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
  EndSelect
  
  ;------------------------------------------------------------------------------------------------
  ; Select the alarm icon. Granularity is only to date scope.
  ;------------------------------------------------------------------------------------------------
  
  AppointmentAlarm.i  = ParseDate("%dd/%mm/%yyyy", Appointment\appAlarm)
  CurrentDate.i       = ParseDate("%dd/%mm/%yyyy", Program\CurrentDate)
  
  If AppointmentAlarm.i < CurrentDate.i       ; If alarm date is less than today's date
    ChangeIcon(#Gadget_AppointmentMuncher_Appointments, LineNumber.i, 2, ImageID(#AlarmRed))
  ElseIf  AppointmentAlarm.i = CurrentDate.i ; If alarm date equals today's date
    ChangeIcon(#Gadget_AppointmentMuncher_Appointments, LineNumber.i, 2, ImageID(#AlarmGreen))
  ElseIf  AppointmentAlarm.i > CurrentDate.i ; If alarm date is greater than today's date
    ChangeIcon(#Gadget_AppointmentMuncher_Appointments, LineNumber.i, 2, ImageID(#AlarmBlue))
  Else
    ChangeIcon(#Gadget_AppointmentMuncher_Appointments, LineNumber.i, 2, ImageID(#AlarmBlank))
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; Show icon in item name field if it posesses an extended comment
  ;------------------------------------------------------------------------------------------------
  
  If Appointment\appComment <> ""
    ChangeIcon(#Gadget_AppointmentMuncher_Appointments, LineNumber.i, 5, ImageID(#AlarmBlank))
  Else
    ChangeIcon(#Gadget_AppointmentMuncher_Appointments, LineNumber.i, 5, ImageID(#HasNote))
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.22 LTS (Windows - x86)
; CursorPosition = 59
; FirstLine = 15
; Folding = -
; EnableXP