﻿;==========================================================================================================================================================
; AppointmentMuncher 'About' window
;==========================================================================================================================================================

Procedure AboutAppointments()
  
  ;------------------------------------------------------------------------------------------------
  ; Check if the alarm module is running first
  ;------------------------------------------------------------------------------------------------
  
  If Program\DontCheck <> 1
  
    ;----------------------------------------------------------------------------------------------
    ; See if there is another window open still
    ;----------------------------------------------------------------------------------------------
    
    If Program\WindowMutex = 0
      
      ;--------------------------------------------------------------------------------------------
      ; Attempt to open the module window
      ;--------------------------------------------------------------------------------------------
      
      If Window_AppointmentAbout()
        
        ;------------------------------------------------------------------------------------------
        ; Set the window check flag so no others will open
        ;------------------------------------------------------------------------------------------
        
        Program\WindowMutex = 1
        
        ;------------------------------------------------------------------------------------------
        ; Warn other components that the alarm checker should not be run right now
        ;------------------------------------------------------------------------------------------
        
        Program\DontCheck = 1
        
        ;------------------------------------------------------------------------------------------
        ; Disable the main window
        ;------------------------------------------------------------------------------------------
        
        DisableWindow(#Window_AppointmentMuncher, 1)
        
        ;------------------------------------------------------------------------------------------
        ; Set the last window (and title message) string
        ;------------------------------------------------------------------------------------------
        
        Program\LastWindow = "About " + #Program
        
        ;------------------------------------------------------------------------------------------
        ; Set the window title here
        ;------------------------------------------------------------------------------------------
        
        SetWindowTitle(#Window_AppointmentAbout, Program\LastWindow)
        
        ;------------------------------------------------------------------------------------------
        ; Remove editorgadget borders
        ;------------------------------------------------------------------------------------------
        
        RemoveBorders(#Gadget_AppointmentAbout_Details)
        
        ;------------------------------------------------------------------------------------------
        ; Add the various keyboard shortcuts
        ;------------------------------------------------------------------------------------------
        
        AddKeyboardShortcut(#Window_AppointmentAbout, #PB_Shortcut_Escape, #Shortcut_AppointmentAbout_Escape)
        
        ;------------------------------------------------------------------------------------------
        ; Stream the RTF 'about' data into the note area from the data section
        ;------------------------------------------------------------------------------------------
        
        CatchRTF(#Gadget_AppointmentAbout_Details, ?_AppointmentMuncher_About)
        
        ;------------------------------------------------------------------------------------------
        ; Display status to the user
        ;------------------------------------------------------------------------------------------
        
        SetInfoBarArea("Headings", "Info", Program\LastWindow)
        
        ;------------------------------------------------------------------------------------------
        ; Display status to the user
        ;------------------------------------------------------------------------------------------
        
      Else
        
        SetInfoBarArea("Headings", "Warn", #InfoStringCannotOpen)
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; Display status to the user
      ;--------------------------------------------------------------------------------------------
      
    Else
      
      SetInfoBarArea("Headings", "Error", #InfoStringWindowOpen, "AboutAppointments")
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; Warn about the alarm checker still running
    ;----------------------------------------------------------------------------------------------
    
  Else
      
    SetInfoBarArea("Headings",  "Warn",  #InfoStringAlarmRunning)
      
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure


; IDE Options = PureBasic 5.22 LTS (Windows - x86)
; CursorPosition = 94
; FirstLine = 83
; Folding = -
; EnableXP